--- old/usr/src/lib/libm/common/m9x/fminl.c	2014-05-04 03:06:43.033018327 +0200
+++ new/usr/src/lib/libm/common/m9x/fminl.c	2014-05-04 03:06:43.063122525 +0200
@@ -51,17 +51,16 @@
 	if (y != y)
 		y = x;
 
-	/* if x is greater than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x != x || x > y)
-#else
-	if (!islessequal(x, y))
-#endif
+	/* if x is nan, replace it by y */
+	if (x != x)
+		x = y;
+
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !islessequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; set the
-	 * sign of the result if either x or y has its sign set
+	 * set the sign of the result if either x or y has its sign set
 	 */
 	xx.ld = x;
 	yy.ld = y;
